<?php

namespace CADSUP\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class ProdutoOrigemController
{
    protected $crudService;
    protected $environment;

    public function __construct($crudService, $environment, $connection)
    {
        $this->crudService       = $crudService;
        $this->environment       = $environment;
        $this->connection        = $connection;
    }

    public function save(Request\Row $request, Response $response)
    {
        $row = $request->getRow();
        $params = array(
            'CDPRODORIG'   => $row['CDPRODUTORIG'],
            'VRFATPERDCMP' => $row['VRFATPERDCMP'],
            'VRFATACRCMP'  => $row['VRFATACRCMP'],
            'P_CDPRODUTO'  => $row['CDPRODUTO']
        );
        $sql = "UPDATE PRODUTO 
                   SET CDPRODORIG = :CDPRODORIG, 
                       VRFATPERDCMP = :VRFATPERDCMP, 
                       VRFATACRCMP  = :VRFATACRCMP 
                 WHERE CDPRODUTO = :P_CDPRODUTO";
        try{
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e){
            $response->setError(new Error($e->getMessage(), 500));
        }    
    }
}    
    